<script lang="ts">
    import { onMount } from 'svelte'
    import { get } from '$lib/fetch'
    import type {
        PlanetCollection,
        PlanetField as PlanetFieldApiType,
        District as DistrictAPI,
        Stargate
    } from '$utils/API/Planet.type'
    import InGame from '$components/Layouts/InGame.svelte'
    import PlanetField from '$components/Planet/PlanetField.svelte'
    import StargatePanel from '$components/Planet/StargatePanel.svelte'
    import DistrictPanel from '$components/Planet/DistrictPanel.svelte'
    import PlanetPanel from '$components/Planet/PlanetPanel.svelte'
    import { districts } from '$lib/districts'
    import type District from '$models/District'

    const size = 33

    let loaded = false
    let fields: PlanetCollection
    let selectedDistrict: DistrictAPI
    let selectedStargate: Stargate

    const coordinatesToField = (x: number, y: number): PlanetFieldApiType | null => {
        if (typeof fields[x] === 'undefined' || typeof fields[x][y] === 'undefined') {
            return null
        }

        return fields[x][y][0]
    }

    onMount(async () => {
        ;({ res: fields } = (await get('api/planet')) as {
            res: PlanetCollection
        })
        loaded = true
    })

    let district: District
    $: {
        if ($districts.length) {
            district = $districts.find(district => district !== undefined)
        }
    }

    const cancelSelection = () => {
        selectedStargate = undefined
        selectedDistrict = undefined
    }

    const selectDistrict = ({ detail: district }: { detail: DistrictAPI }) => {
        selectedStargate = undefined
        selectedDistrict = district
    }

    const selectStargate = ({ detail: stargate }: { detail: Stargate }) => {
        selectedDistrict = undefined
        selectedStargate = stargate
    }
</script>

<svelte:head>
    <title>Planet</title>
</svelte:head>

<InGame {loaded}>
    <article>
        <aside>
            {#if selectedStargate}
                <StargatePanel stargate={selectedStargate} on:cancel={cancelSelection} {district} />
            {:else if selectedDistrict}
                <DistrictPanel district={selectedDistrict} on:cancel={cancelSelection} />
            {:else}
                <PlanetPanel {fields} {district} on:select={selectStargate} />
            {/if}
        </aside>
        <main>
            {#each Array(size) as _, y}
                {#each Array(size) as _, x}
                    <PlanetField
                        field={coordinatesToField(x, y)}
                        on:selectDistrict={selectDistrict}
                        on:selectStargate={selectStargate}
                        on:selectEmpty={cancelSelection}
                    />
                {/each}
            {/each}
        </main>
    </article>
</InGame>

<style lang="postcss">
    article {
        @apply relative flex-1 flex pt-[4.5rem];

        aside {
            @apply relative w-[calc(2/7*100%)];
            clip-path: polygon(calc(100% - 2rem) 0.75rem, 100% 100%, 0 100%, 0 0);

            &::before {
                content: '';
                @apply absolute inset-0 z-[-1] bg-trueGray-100 dark:bg-trueGray-900;
            }
        }

        main {
            @apply relative flex-1 m-4 grid gap-0.5;
            grid-template-columns: repeat(33, minmax(0, 1fr));
        }
    }
</style>
